% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_gMAP.R
\name{plot.gMAP}
\alias{plot.gMAP}
\title{Diagnostic plots for gMAP analyses}
\usage{
\method{plot}{gMAP}(x, size = NULL, ...)
}
\arguments{
\item{x}{\code{\link{gMAP}} object}

\item{size}{Controls line sizes of traceplots and forest plot.}

\item{...}{Ignored.}
}
\value{
The function returns a list of \code{\link{ggplot}}
objects.
}
\description{
Diagnostic plots for gMAP analyses
}
\details{
Creates MCMC diagnostics and a forest plot (including
model estimates) for a \code{\link{gMAP}} analysis. For a
customized forest plot, please use the dedicated function
\code{\link{forest_plot}}.
}
\section{Customizing \pkg{ggplot2} plots}{


The returned plot is a \pkg{ggplot2} object. Please refer to the
"Customizing Plots" vignette which is part of \pkg{RBesT}
documentation for an introduction. For simple modifications (change
labels, add reference lines, ...) consider the commands found in
\code{\link[bayesplot]{bayesplot-helpers}}. For more advanced
customizations please use the \pkg{ggplot2} package directly. A
description of the most common tasks can be found in the
\href{http://www.cookbook-r.com/Graphs/}{R Cookbook} and a full
reference of available commands can be found at the
\href{https://ggplot2.tidyverse.org/reference/}{ggplot2 documentation
site}.
}

